/* ========================================
 *  Density2 - Density2.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Density2_Density2_H
#define __Density2_Density2_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Density2 {
enum {
	kParamA = 0,
	kParamB = 1,
	kParamC = 2,
	kParamD = 3,
  kNumParameters = 4
}; //


class Density2 final : public SfxCoreExtensionV1
{
public:
    Density2();
    ~Density2();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff

	double last3SampleL;
	double last2SampleL;
	double last1SampleL;
	double ataAL;
	double ataBL;
	double ataCL;
	double lastDiffSampleL;
	double iirSampleAL;
	double iirSampleBL;

	double last3SampleR;
	double last2SampleR;
	double last1SampleR;
	double ataAR;
	double ataBR;
	double ataCR;
	double lastDiffSampleR;
	double iirSampleAR;
	double iirSampleBR;
	
    float A;
    float B;
    float C;
    float D;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
